#include <LiquidCrystal.h>

LiquidCrystal lcd(2, 3, 4, 5, 6, 7);

void setup(){  
  pinMode(8,OUTPUT);
  pinMode(9,OUTPUT);
  pinMode(10,OUTPUT);
  pinMode(11,OUTPUT);
  pinMode(A3, INPUT_PULLUP);
  lcd.begin(16, 2);
  lcd.print("A/D izhod:");
  lcd.setCursor(0, 1);
  lcd.print("koraki:");
}

void loop(){
  int potValue = analogRead(A0);
  lcd.setCursor(12,0);
  if (potValue > 999 ) {
  } else if (potValue > 99) {
    lcd.print(" ");
  } else if (potValue > 9) {
    lcd.print("  ");
  } else {
    lcd.print("   ");
  }
  lcd.print(potValue);

  int steps = 0;
  if (potValue<512) {
    steps = (potValue - 512) * 4;
  } else {
    steps = (potValue - 511) * 4;
  }
  lcd.setCursor(11,1);
  if (steps > 999 ) {
    lcd.print(" ");
  } else if (steps > 99) {
    lcd.print("  ");
  } else if (steps > 9) {
    lcd.print("   ");
  } else if (steps > 0) {
    lcd.print("    ");
  } else if (steps > -10) {
    lcd.print("   ");
  } else if (steps > -100) {
    lcd.print("  ");
  } else if (steps > -1000) {
    lcd.print(" ");
  }
  lcd.print(steps);

  if (!digitalRead(A3)) {
    int s_direction = 0;
    if (steps > 0) {
      s_direction = 1;
    } else {
      s_direction = -1;
    }
    for (int i = 0; i < abs(steps); i++) {
      step_move(i*s_direction);
      if(!digitalRead(A3)) {
        delay(1000);
      } else {
        delay(2);
      }
    }
    PORTB &= ~(0b001111);
  }
}

void step_move(int si) {
  //                         DCBA
  const byte s_table[4] = {0b1001,
                           0b0011,
                           0b0110,
                           0b1100};
  si = si & 0b0000011;
  byte s_step = PORTB;
  s_step &= ~(0b001111);
  s_step |= s_table[si];
  PORTB = s_step;
}
